/*
*	Glide64 - Glide video plugin for Nintendo 64 emulators.
*	Copyright (c) 2002  Dave2001
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//****************************************************************
//
// Glide64 - Glide Plugin for Nintendo 64 emulators (tested mostly with Project64)
// Project started on December 29th, 2001
//
// To modify Glide64:
// * Write your name and (optional)email, commented by your work, so I know who did it, and so that you can find which parts you modified when it comes time to send it to me.
// * Do NOT send me the whole project or file that you modified.  Take out your modified code sections, and tell me where to put them.  If people sent the whole thing, I would have many different versions, but no idea how to combine them all.
//
// Official Glide64 development channel: #Glide64 on EFnet
//
// Original author: Dave2001 (Dave2999@hotmail.com)
// Other authors: Gonetz, Gugaman
//
//****************************************************************
//
// Creation 13 August 2003               Gonetz
//
//****************************************************************

static void fb_uc0_moveword()
{
  if ((rdp.cmd0 & 0xFF) == 0x06)  // segment
  {
    rdp.segment[(rdp.cmd0 >> 10) & 0x0F] = rdp.cmd1;
  }
}

static void fb_uc2_moveword()
{
  if (((rdp.cmd0 >> 16) & 0xFF) == 0x06)  // segment
  {
    rdp.segment[((rdp.cmd0 & 0xFFFF) >> 2)&0xF] = rdp.cmd1;
  }
}

/*
static void fb_uc2_movemem()
{
  if (rdp.ci_count && (rdp.frame_buffers[rdp.ci_count-1].width < rdp.frame_buffers[rdp.main_ci_index].width))
  {
    if ((rdp.cmd0 & 0xFF) == 8) // VIEWPORT
    {
      DWORD a = segoffset(rdp.cmd1) >> 1;
      short y = ((short*)gfx.RDRAM)[(a+1)^1] >> 2;
      y += ((short*)gfx.RDRAM)[(a+5)^1] >> 2;
      if ((y > 0)  && ((WORD)y < rdp.frame_buffers[rdp.ci_count-1].height))
        rdp.frame_buffers[rdp.ci_count-1].height = y;
    }
  }
}
*/

static void fb_bg_copy ()
{
  if (rdp.main_ci == 0)
    return;
  CI_STATUS status = rdp.frame_buffers[rdp.ci_count-1].status;
  if ( (status == ci_copy) || (status == ci_main_i) )
    return;
  
  DWORD addr = segoffset(rdp.cmd1) >> 1;
  BYTE imageFmt	= ((BYTE *)gfx.RDRAM)[(((addr+11)<<1)+0)^3];
  BYTE imageSiz	= ((BYTE *)gfx.RDRAM)[(((addr+11)<<1)+1)^3];	
  DWORD imagePtr	= segoffset(((DWORD*)gfx.RDRAM)[(addr+8)>>1]);	
  FRDP ("fb_bg_copy. fmt: %d, size: %d, imagePtr %08lx, main_ci: %08lx, cur_ci: %08lx \n", imageFmt, imageSiz, imagePtr, rdp.main_ci, rdp.frame_buffers[rdp.ci_count-1].addr);
  
  if (status == ci_main)
  {
	WORD frameW	= ((WORD *)gfx.RDRAM)[(addr+3)^1] >> 2;	
	WORD frameH	= ((WORD *)gfx.RDRAM)[(addr+7)^1] >> 2;	
	if ( (frameW == rdp.frame_buffers[rdp.ci_count-1].width) && (frameH == rdp.frame_buffers[rdp.ci_count-1].height) )
	  rdp.main_ci_bg = imagePtr;
  }
  else if (imagePtr >= rdp.main_ci && imagePtr < rdp.main_ci_end) //addr within main frame buffer
  {
    rdp.copy_ci_index = rdp.ci_count-1;
    rdp.frame_buffers[rdp.copy_ci_index].status = ci_copy;
    FRDP("rdp.frame_buffers[%d].status = ci_copy\n", rdp.copy_ci_index);
	
    if (rdp.frame_buffers[rdp.copy_ci_index].addr != rdp.main_ci_bg)
    {
      rdp.scale_x = 1.0f;
      rdp.scale_y = 1.0f;
    }
    else 
    {
      RDP("motion blur!\n");
      rdp.motionblur = TRUE;
    }
	
    FRDP ("Detect FB usage. texture addr is inside framebuffer: %08lx - %08lx \n", imagePtr, rdp.main_ci);
  }
  else if (imagePtr == rdp.zimg)
  {
    if (status == ci_unknown)
    {
      rdp.frame_buffers[rdp.ci_count-1].status = ci_zimg;
      rdp.tmpzimg = rdp.frame_buffers[rdp.ci_count-1].addr;
      FRDP("rdp.frame_buffers[%d].status = ci_zimg\n", rdp.copy_ci_index);
    }
  }
}

static void fb_setscissor()
{
  rdp.scissor_o.lr_y = (DWORD)(((rdp.cmd1 & 0x00000FFF) >> 2));
  if (rdp.frame_buffers[rdp.ci_count-1].height == 0) 
    rdp.frame_buffers[rdp.ci_count-1].height = rdp.scissor_o.lr_y;
}

static void fb_rect()
{
  if (rdp.frame_buffers[rdp.ci_count-1].width == 32)
    return;
  int lr_x = ((rdp.cmd0 & 0x00FFF000) >> 14) + 1;
  if ((int)rdp.frame_buffers[rdp.ci_count-1].width - lr_x <= 0)
    rdp.frame_buffers[rdp.ci_count-1].height = rdp.scissor_o.lr_y;
}

static void fb_settextureimage()
{
  if (rdp.main_ci == 0)
    return;
  CI_STATUS status = rdp.frame_buffers[rdp.ci_count-1].status;
  if ( status >= ci_copy )
    return;
  if ( (((rdp.cmd0 >> 21) & 0x07) == 0) &&
       (((rdp.cmd0 >> 19) & 0x03) == 2) ) //check that texture is 16bit RGBA
  {
    DWORD addr = segoffset(rdp.cmd1);
    FRDP ("fb_settextureimage. fmt: %d, size: %d, imagePtr %08lx, main_ci: %08lx, cur_ci: %08lx \n", ((rdp.cmd0 >> 21) & 0x07), ((rdp.cmd0 >> 19) & 0x03), addr, rdp.main_ci, rdp.frame_buffers[rdp.ci_count-1].addr);
    if (status == ci_main) 
    {
      rdp.main_ci_last_tex_addr = addr;
    }
    if ((addr >= rdp.main_ci) && (addr < rdp.main_ci_end)) //addr within main frame buffer
    {
    	if (status == ci_main)
    	{
    	  if (rdp.main_ci_index == rdp.ci_count-1)
    	  {
            rdp.copy_ci_index = rdp.ci_count-1;
      	    rdp.frame_buffers[rdp.copy_ci_index].status = ci_copy_self;
            FRDP("rdp.frame_buffers[%d].status = ci_copy_self\n", rdp.ci_count-1);
    	  }
    	  else
    	  {
      	    rdp.frame_buffers[rdp.ci_count-1].status = ci_main_i;
            FRDP("rdp.frame_buffers[%d].status = ci_main_i\n", rdp.ci_count-1);
          }
        }
    	else
    	{
   	  	  if (rdp.frame_buffers[rdp.ci_count-1].width == rdp.frame_buffers[rdp.main_ci_index].width)
   	  	  {
            rdp.copy_ci_index = rdp.ci_count-1;
    	    rdp.frame_buffers[rdp.copy_ci_index].status = ci_copy;
            FRDP("rdp.frame_buffers[%d].status = ci_copy\n", rdp.copy_ci_index);
            if ((rdp.main_ci_last_tex_addr >= rdp.frame_buffers[rdp.ci_count-1].addr) && 
              (rdp.main_ci_last_tex_addr < (rdp.frame_buffers[rdp.ci_count-1].addr + rdp.frame_buffers[rdp.ci_count-1].width*rdp.frame_buffers[rdp.ci_count-1].height*rdp.frame_buffers[rdp.ci_count-1].size)))
            {
              RDP("motion blur!\n");
	  	      rdp.motionblur = TRUE;
	  	    }
	  	    else 
            {
         	  rdp.scale_x = 1.0f;
        	  rdp.scale_y = 1.0f;
            }
          }
        }
    	FRDP ("Detect FB usage. texture addr is inside framebuffer: %08lx - %08lx \n", addr, rdp.main_ci);
    }
///*
    else if ((status != ci_main) && (addr >= rdp.zimg && addr < rdp.zimg_end))
    {
   	  rdp.frame_buffers[rdp.ci_count-1].status = ci_zcopy;
      FRDP("fb_settextureimage. rdp.frame_buffers[%d].status = ci_zcopy\n", rdp.ci_count-1);
    }
//*/
    else if ((addr >= rdp.maincimg[0]) && (addr < (rdp.maincimg[0] + rdp.ci_width*rdp.ci_height*2))) 
    {
      if (rdp.frame_buffers[rdp.ci_count-1].status != ci_main)
      {
  	    rdp.frame_buffers[rdp.ci_count-1].status = ci_old_copy;
        FRDP("rdp.frame_buffers[%d].status = ci_old_copy\n", rdp.ci_count-1);
      }
      rdp.read_previous_ci = TRUE;
    }
  }
  if (rdp.frame_buffers[rdp.ci_count-1].status == ci_unknown)
  {
 	  rdp.frame_buffers[rdp.ci_count-1].status = ci_aux;
      FRDP("fb_settextureimage. rdp.frame_buffers[%d].status = ci_aux\n", rdp.ci_count-1);
  }
}

static void fb_loadtxtr()
{
  if (rdp.frame_buffers[rdp.ci_count-1].status == ci_unknown)
  {
 	  rdp.frame_buffers[rdp.ci_count-1].status = ci_aux;
      FRDP("rdp.frame_buffers[%d].status = ci_aux\n", rdp.ci_count-1);
  }
}

static void fb_setdepthimage()
{
  rdp.zimg = segoffset(rdp.cmd1) & BMASK;
  rdp.zimg_end = rdp.zimg + rdp.ci_width*rdp.ci_height*2;
  FRDP ("fb_setdepthimage. addr %08lx\n", rdp.zimg);
  if (rdp.zimg == rdp.main_ci)  //strange, but can happen
  {
    rdp.frame_buffers[rdp.main_ci_index].status = ci_unknown;
    if (rdp.main_ci_index < rdp.ci_count)
    {
      rdp.frame_buffers[rdp.main_ci_index].status = ci_zimg;
      FRDP("rdp.frame_buffers[%d].status = ci_zimg\n", rdp.main_ci_index);
      rdp.main_ci_index++;
      rdp.frame_buffers[rdp.main_ci_index].status = ci_main;
      FRDP("rdp.frame_buffers[%d].status = ci_main\n", rdp.main_ci_index);
      rdp.main_ci = rdp.frame_buffers[rdp.main_ci_index].addr;
      rdp.main_ci_end = rdp.main_ci + (rdp.frame_buffers[rdp.main_ci_index].width * rdp.frame_buffers[rdp.main_ci_index].height * rdp.frame_buffers[rdp.main_ci_index].size);
    }
    else
    {
      rdp.main_ci = 0;
    }
  }
  for (int i = 0; i < rdp.ci_count; i++)
  {
    if ((rdp.frame_buffers[i].addr == rdp.zimg) && (rdp.frame_buffers[i].status == ci_aux))
      rdp.frame_buffers[i].status = ci_zimg;
  }
}

static void fb_setcolorimage()
{
  rdp.ocimg = rdp.cimg;
  rdp.cimg = segoffset(rdp.cmd1) & BMASK;
  rdp.frame_buffers[rdp.ci_count].width = (rdp.cmd0 & 0xFFF) + 1;
  if (rdp.frame_buffers[rdp.ci_count].width == 32 ) 
    rdp.frame_buffers[rdp.ci_count].height = 32;
  else if (rdp.ci_count > 0)
    rdp.frame_buffers[rdp.ci_count].height = rdp.scissor_o.lr_y;
  else
    rdp.frame_buffers[rdp.ci_count].height = 0;
  rdp.frame_buffers[rdp.ci_count].format = (rdp.cmd0 >> 21) & 0x7;
  rdp.frame_buffers[rdp.ci_count].size = (rdp.cmd0 >> 19) & 0x3;
  rdp.frame_buffers[rdp.ci_count].addr = rdp.cimg;
/*
  if (rdp.ci_count > 0)
    if (rdp.frame_buffers[0].addr == rdp.cimg)
      rdp.frame_buffers[0].height = rdp.scissor_o.lr_y;
*/
  FRDP ("fb_setcolorimage. width: %d,  height: %d,  fmt: %d, size: %d, addr %08lx\n", rdp.frame_buffers[rdp.ci_count].width, rdp.frame_buffers[rdp.ci_count].height, rdp.frame_buffers[rdp.ci_count].format, rdp.frame_buffers[rdp.ci_count].size, rdp.frame_buffers[rdp.ci_count].addr);
  if ((rdp.cimg == rdp.zimg) || (rdp.cimg == rdp.tmpzimg))
  {
    rdp.frame_buffers[rdp.ci_count].status = ci_zimg;
    FRDP("rdp.frame_buffers[%d].status = ci_zimg\n", rdp.ci_count);
  }
  else if (rdp.main_ci != 0)
  {
    if (rdp.cimg == rdp.main_ci) //switched to main fb again 
    {
      rdp.main_ci_index = rdp.ci_count;
      rdp.main_ci_end = rdp.cimg + (rdp.frame_buffers[rdp.ci_count].width * rdp.frame_buffers[rdp.ci_count].height * rdp.frame_buffers[rdp.ci_count].size);
      rdp.frame_buffers[rdp.ci_count].status = ci_main;
      FRDP("rdp.frame_buffers[%d].status = ci_main\n", rdp.ci_count);
    }
    else // status is not known yet
    {
      rdp.frame_buffers[rdp.ci_count].status = ci_unknown;
    }
  }
  else
  {
    if ((rdp.zimg != rdp.cimg))//&& (rdp.ocimg != rdp.cimg))
    {
      rdp.main_ci = rdp.cimg;
      rdp.main_ci_end = rdp.cimg + ((rdp.frame_buffers[rdp.ci_count].width * rdp.frame_buffers[rdp.ci_count].height / 2) << rdp.frame_buffers[rdp.ci_count].size);
      rdp.main_ci_index = rdp.ci_count;
      rdp.frame_buffers[rdp.ci_count].status = ci_main;
      FRDP("rdp.frame_buffers[%d].status = ci_main\n", rdp.ci_count);
    }
    else
    {
      rdp.frame_buffers[rdp.ci_count].status = ci_unknown;
    }
    
  }	
  if (rdp.frame_buffers[rdp.ci_count-1].status == ci_unknown) //status of previous fb was not changed - it is useless
  {
    if (settings.fb_hires)
    {
      rdp.frame_buffers[rdp.ci_count-1].status = ci_aux;
      FRDP("rdp.frame_buffers[%d].status = ci_aux\n", rdp.ci_count-1);
    }
    else
    {
      rdp.frame_buffers[rdp.ci_count-1].status = ci_useless;
      FRDP("rdp.frame_buffers[%d].status = ci_useless\n", rdp.ci_count-1);
    }
  }
  rdp.ci_count++;
}

// RDP graphic instructions pointer table used in DetectFrameBufferUsage

static rdp_instr gfx_instruction_lite[9][256] =
{
  {
	// uCode 0 - RSP SW 2.0X
	// 00-3f
	// games: Super Mario 64, Tetrisphere, Demos
	0,                     0,             0,              0,
	  0,             0,              uc0_displaylist,        0,
	  0,              0,           0,                      0,
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  // 40-7f: Unused
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  // 80-bf: Immediate commands
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  uc0_enddl,              0,     					0,    					0,
	  fb_uc0_moveword,           0,          			uc0_culldl,             0,
	  // c0-ff: RDP commands
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                      0,                      0,                      0,        
	  0,                  0,                  0,                  0,    
	  0,                  0,                  0,                  0,    
	  0,                  0,                  0,                  0,    
	  0,                  0,                  0,                  0,    
	  0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
  },
  
  // uCode 1 - F3DEX 1.XX
  // 00-3f
  // games: Mario Kart, Star Fox
  {
	  0,                      0,                      0,                      0,        
        0,             0,              uc0_displaylist,        0,
        0,              0,           0,                      0,
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
		// 40-7f: unused
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
		// 80-bf: Immediate commands
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      uc6_loaducode,        
        uc1_branch_z,           0,               0,		   0,
        uc1_rdphalf_1,          0,             0,  0,
        uc0_enddl,              0,     0,     0,
        fb_uc0_moveword,           0,          uc2_culldl,             0,
		// c0-ff: RDP commands
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
	  },
	  
	  // uCode 2 - F3DEX 2.XX
	  // games: Zelda 64
	  {
		// 00-3f
		0,					0,				0,			uc2_culldl,
		  uc1_branch_z,			0,				0,			0,
		  0,				fb_bg_copy,			fb_bg_copy,			0,
		  0,					0,					0,					0,
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // 40-7f: unused
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // 80-bf: unused
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // c0-ff: RDP commands mixed with uc2 commands
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,			uc2_dlist_cnt,				0,					0,
		  0,			0,			0,				fb_uc2_moveword,
		  0/*fb_uc2_movemem*/,			uc2_load_ucode,			uc0_displaylist,	uc0_enddl,
		  0,					uc1_rdphalf_1,			0, 		0,
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
		},
		
		// uCode 3 - "RSP SW 2.0D", but not really
		// 00-3f
		// games: Wave Race
		// ** Added by Gonetz **
		{
		  0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			// 40-7f: unused
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			// 80-bf: Immediate commands
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                      0,                      0,                      0,        
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			uc0_enddl,              0,     0,     0,
			fb_uc0_moveword,           0,          uc0_culldl,             0,
			// c0-ff: RDP commands
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
			0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
		  },
		  
		  {
			// uCode 4 - RSP SW 2.0D EXT
			// 00-3f
			// games: Star Wars: Shadows of the Empire
			0,                  0,                  0,                  0,    
			  0,             0,              uc0_displaylist,        0,
			  0,                  0,                  0,                  0,    
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  // 40-7f: Unused
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  // 80-bf: Immediate commands
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                      0,                      0,                      0,        
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  uc0_enddl,              0,     0,     0,
			  fb_uc0_moveword,           0,          uc0_culldl,             0,
			  // c0-ff: RDP commands
			  rdp_noop,               0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
			  0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
			},
			
			{
			  // uCode 5 - RSP SW 2.0 Diddy
			  // 00-3f
			  // games: Diddy Kong Racing
			  	0,         				0,         				0,       				0,
				0,						0,			       uc0_displaylist,			 uc5_dl_in_mem,
				0,              		0,           			0,                      0,
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				// 40-7f: Unused
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				// 80-bf: Immediate commands
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                      0,                      0,                      0,        
				0,                  	0,                  	0,                  	0,    
				uc0_enddl,              0,     					0,     					0,
				fb_uc0_moveword,        0,          			uc0_culldl,             0,
				// c0-ff: RDP commands
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
				0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
			  },
			  
			  // uCode 6 - S2DEX 1.XX
			  // games: Yoshi's Story
			  {
				0,                  0,                  0,                  0,    
				  0,             0,         uc0_displaylist,        0,
				  0,                  0,                  0,                  0,    
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  // 40-7f: unused
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  // 80-bf: Immediate commands
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      0,        
				  0,                      0,                      0,                      uc6_loaducode,        
				  uc6_select_dl,          0,         0,		0,
				  0,                  0,                  0,                  0,    
				  uc0_enddl,              0,     0,     0,
				  fb_uc0_moveword,           0,          uc2_culldl,             0,
				  // c0-ff: RDP commands
        		  0,               fb_loadtxtr,       fb_loadtxtr,    fb_loadtxtr,
                  fb_loadtxtr,        0,                  0,                  0,
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
				  0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
				},
				
  {
	  	0,                      0,                      0,                      0,        
        0,             			0,              		uc0_displaylist,        0,
        0,              		0,           			0,                      0,
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
		// 40-7f: unused
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
		// 80-bf: Immediate commands
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,           			0,               		0,		   				0,
        0,          			0,             			0,  					0,
        uc0_enddl,              0,     					0,     					0,
        fb_uc0_moveword,        0,          			uc0_culldl,             0,
		// c0-ff: RDP commands
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                      0,                      0,                      0,        
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
        0,                  0,                  0,                  0,    
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
	  },

	  {
		// 00-3f
		0,					0,				0,			uc2_culldl,
		  uc1_branch_z,			0,				0,			0,
		  0,				fb_bg_copy,			fb_bg_copy,			0,
		  0,					0,					0,					0,
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // 40-7f: unused
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // 80-bf: unused
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  0,					0,					0,					0,
		  
		  // c0-ff: RDP commands mixed with uc2 commands
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,			uc2_dlist_cnt,				0,					0,
		  0,			0,			0,				fb_uc2_moveword,
		  0,			uc2_load_ucode,			uc0_displaylist,	uc0_enddl,
		  0,			uc1_rdphalf_1,			  0, 				  0,
		  fb_rect,         fb_rect,         	  0,                  0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_setscissor,         0,       0,
		  0,                  0,                  0,                  0,    
		  0,                  0,            	fb_rect,              0,    
		  0,                  0,                  0,                  0,    
		  0,         fb_settextureimage,    fb_setdepthimage,      fb_setcolorimage
		}
};
